Index: LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/physiq.F	(revision 781)
+++ LMDZ4/trunk/libf/phylmd/physiq.F	(revision 782)
@@ -26,4 +26,19 @@
       USE misc_mod, mydebug=>debug
       USE vampir
+      USE pbl_surface_mod, ONLY : pbl_surface
+
+#ifdef INCA
+cym      USE chemshut
+      USE species_names
+#ifdef INCA_CH4
+!      USE obs_pos
+#endif
+#endif
+
+      USE ocean_slab_mod, ONLY   : ocean_slab_get_vars
+      USE ocean_cpl_mod, ONLY    : ocean_cpl_get_vars
+      USE ocean_forced_mod, ONLY : ocean_forced_get_vars
+      USE fonte_neige_mod, ONLY  : fonte_neige_get_vars
+
       IMPLICIT none
 c======================================================================
@@ -70,8 +85,4 @@
 c d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
 c omega---input-R-vitesse verticale en Pa/s
-cIM comgeomphy.h BEG
-c cuphy----input-R-resolution des mailles en x (m)
-c cvphy----input-R-resolution des mailles en y (m)
-cIM comgeomphy.h END
 c d_u-----output-R-tendance physique de "u" (m/s/s)
 c d_v-----output-R-tendance physique de "v" (m/s/s)
@@ -87,5 +98,5 @@
       integer iip1
       parameter (iip1=iim+1)
-cym#include "dimphy.h"
+
 #include "regdim.h"
 #include "indicesol.h"
@@ -110,8 +121,4 @@
       PARAMETER (ok_stratus=.FALSE.)
 c======================================================================
-c Parametres lies au coupleur OASIS:
-#include "oasis.h"
-      INTEGER,SAVE :: npas, nexca
-c$OMP THREADPRIVATE(npas, nexca)
       logical rnpb
 #ifdef INCA
@@ -124,10 +131,5 @@
       SAVE ocean
 c$OMP THREADPRIVATE(ocean)
-c      parameter (ocean = 'force ')
-c     parameter (ocean = 'couple')
-      logical ok_ocean
-      SAVE ok_ocean
-c$OMP THREADPRIVATE(ok_ocean)
-c
+
 cIM "slab" ocean
       REAL tslab(klon)    !Temperature du slab-ocean
@@ -167,15 +169,12 @@
       save ok_journe
 c$OMP THREADPRIVATE(ok_journe)
-c      PARAMETER (ok_journe=.true.)
 c
       LOGICAL ok_mensuel ! sortir le fichier mensuel
       save ok_mensuel
 c$OMP THREADPRIVATE(ok_mensuel)
-c      PARAMETER (ok_mensuel=.true.)
 c
       LOGICAL ok_instan ! sortir le fichier instantane
       save ok_instan
 c$OMP THREADPRIVATE(ok_instan)
-c      PARAMETER (ok_instan=.true.)
 c
       LOGICAL ok_region ! sortir le fichier regional
@@ -185,7 +184,4 @@
       REAL fm_therm(klon,klev+1)
       REAL entr_therm(klon,klev)
-      real,allocatable,save :: q2(:,:,:)
-c$OMP THREADPRIVATE(q2)
-cym      save q2
 c======================================================================
 c
@@ -212,6 +208,4 @@
       REAL presnivs(klev)
       REAL znivsig(klev)
-      REAL zsurf(nbsrf)
-      INTEGER kinv
       real pir
 
@@ -223,5 +217,4 @@
       REAL,allocatable,save :: t_ancien(:,:), q_ancien(:,:)
 c$OMP THREADPRIVATE(t_ancien, q_ancien)
-cym      SAVE t_ancien, q_ancien
       LOGICAL ancien_ok
       SAVE ancien_ok
@@ -268,24 +261,19 @@
       REAL,allocatable,save :: swup0(:,:), swup(:,:)
 c$OMP THREADPRIVATE(swdn0 , swdn, swup0, swup)
-cym      SAVE swdn0 , swdn, swup0, swup
 c
       REAL,allocatable,save :: SWdn200clr(:), SWdn200(:)
       REAL,allocatable,save :: SWup200clr(:), SWup200(:)
 c$OMP THREADPRIVATE(SWdn200clr, SWdn200, SWup200clr, SWup200)
-cym      SAVE SWdn200clr, SWdn200, SWup200clr, SWup200
 c
       REAL,allocatable,save :: lwdn0(:,:), lwdn(:,:)
       REAL,allocatable,save :: lwup0(:,:), lwup(:,:)
 c$OMP THREADPRIVATE(lwdn0 , lwdn, lwup0, lwup)
-cym      SAVE lwdn0 , lwdn, lwup0, lwup 
 c
       REAL,allocatable,save :: LWdn200clr(:), LWdn200(:)
       REAL,allocatable,save :: LWup200clr(:), LWup200(:)
 c$OMP THREADPRIVATE(LWdn200clr, LWdn200, LWup200clr, LWup200)
-cym      SAVE LWdn200clr, LWdn200, LWup200clr, LWup200
 c
       REAL,allocatable,save :: LWdnTOA(:), LWdnTOAclr(:)
 c$OMP THREADPRIVATE(LWdnTOA, LWdnTOAclr)
-cym      SAVE LWdnTOA, LWdnTOAclr
 c
 cIM Amip2
@@ -323,7 +311,4 @@
       REAL,SAVE,ALLOCATABLE :: wsumSTD(:,:,:), phisumSTD(:,:,:)
       REAL,SAVE,ALLOCATABLE :: qsumSTD(:,:,:), rhsumSTD(:,:,:)
-c
-cym      SAVE tsumSTD, usumSTD, vsumSTD, wsumSTD, phisumSTD, 
-cym     .     qsumSTD, rhsumSTD
 c$OMP THREADPRIVATE(tsumSTD, usumSTD, vsumSTD, wsumSTD, phisumSTD) 
 c$OMP THREADPRIVATE(qsumSTD, rhsumSTD)
@@ -332,5 +317,4 @@
       real,SAVE,ALLOCATABLE :: tnondef(:,:,:) 
 c$OMP THREADPRIVATE(tnondef)
-cym      save tnondef
 c
 c les produits uvSTD, vqSTD, .., T2STD sont calcules
@@ -360,6 +344,4 @@
       real,save,allocatable :: T2sumSTD(:,:,:)
 c
-cym      SAVE uvsumSTD, vqsumSTD, vTsumSTD, wqsumSTD
-cym      SAVE vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, T2sumSTD
 c$OMP THREADPRIVATE(uvsumSTD, vqsumSTD, vTsumSTD, wqsumSTD)
 c$OMP THREADPRIVATE(vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, T2sumSTD)
@@ -433,5 +415,4 @@
       REAL seed_re(klon,napisccp)
       INTEGER,ALLOCATABLE,SAVE :: seed_old(:,:)
-cym      SAVE seed_old
 c$OMP THREADPRIVATE(seed_old)
 cym !!!! A voir plus tard 
@@ -511,5 +492,4 @@
       PARAMETER(nbregdyn=5)
 
-      INTEGER linv
       INTEGER,ALLOCATABLE,SAVE :: pct_ocean(:,:)
 c$OMP THREADPRIVATE(pct_ocean)
@@ -683,6 +663,5 @@
 
       REAL,allocatable,save :: ftsol(:,:)
-c$OMP THREADPRIVATE(ftsol)
-cym      SAVE ftsol                  ! temperature du sol
+c$OMP THREADPRIVATE(ftsol)       ! temperature du sol
 
 cIM
@@ -691,14 +670,6 @@
 cym     SAVE newsst
 c
-      REAL,allocatable,save :: ftsoil(:,:,:)
-c$OMP THREADPRIVATE(ftsoil)
-cym      SAVE ftsoil                 ! temperature dans le sol
-c
-      REAL,allocatable,save :: fevap(:,:)
-c$OMP THREADPRIVATE(fevap)
-cym      SAVE fevap                 ! evaporation
-      REAL,allocatable,save :: fluxlat(:,:)
-c$OMP THREADPRIVATE(fluxlat)
-cym      SAVE fluxlat
+      REAL fevap(klon,nbsrf)
+      REAL fluxlat(klon,nbsrf)
 c
       REAL,allocatable,save :: deltat(:)
@@ -706,22 +677,11 @@
 cym      SAVE deltat                 ! ecart avec la SST de reference
 c
-      REAL,allocatable,save :: fqsurf(:,:)
-c$OMP THREADPRIVATE(fqsurf)
-cym      SAVE fqsurf                 ! humidite de l'air au contact de la surface
-c
-      REAL,allocatable,save :: qsol(:)
-c$OMP THREADPRIVATE(qsol)
-cym      SAVE qsol                  ! hauteur d'eau dans le sol
-c
-      REAL,allocatable,save :: fsnow(:,:)
-c$OMP THREADPRIVATE(fsnow)
-cym      SAVE fsnow                  ! epaisseur neigeuse
+      REAL qsol(klon)
 c
       REAL,allocatable,save :: falbe(:,:)
-c$OMP THREADPRIVATE(falbe)
-cym      SAVE falbe                  ! albedo par type de surface
+c$OMP THREADPRIVATE(falbe)       ! albedo par type de surface
+c
       REAL,allocatable,save :: falblw(:,:)
-c$OMP THREADPRIVATE(falblw)      
-cym      SAVE falblw                 ! albedo par type de surface
+c$OMP THREADPRIVATE(falblw)       ! albedo par type de surface
 
 c
@@ -770,7 +730,5 @@
       INTEGER igwd,idx(klon),itest(klon)
 c
-      REAL,allocatable,save :: agesno(:,:)
-c$OMP THREADPRIVATE(agesno)
-cym      SAVE agesno                 ! age de la neige
+      REAL agesno(klon,nbsrf)
 c
       REAL,allocatable,save :: alb_neig(:)
@@ -778,6 +736,6 @@
 cym      SAVE alb_neig               ! albedo de la neige
 c
-      REAL,allocatable,save :: run_off_lic_0(:)
-c$OMP THREADPRIVATE(run_off_lic_0)
+c      REAL,allocatable,save :: run_off_lic_0(:)
+cc$OMP THREADPRIVATE(run_off_lic_0)
 cym      SAVE run_off_lic_0
 cKE43
@@ -836,12 +794,5 @@
       REAL yu1(klon)            ! vents dans la premiere couche U
       REAL yv1(klon)            ! vents dans la premiere couche V
-      REAL,SAVE,ALLOCATABLE :: ffonte(:,:)    !Flux thermique utilise pour fondre la neige
-c$OMP THREADPRIVATE(ffonte)
-      REAL,SAVE,ALLOCATABLE :: fqcalving(:,:) !Flux d'eau "perdu" par la surface 
-c$OMP THREADPRIVATE(fqcalving)
-      REAL,SAVE,ALLOCATABLE :: fqfonte(:,:)  !Quantite d'eau de fonte des glaciers
-c$OMP THREADPRIVATE(fqfonte)
-c                               !et necessaire pour limiter la
-c                               !hauteur de neige, en kg/m2/s
+
       REAL zxffonte(klon), zxfqcalving(klon),zxfqfonte(klon)
 
@@ -882,9 +833,5 @@
       REAL evap(klon), devap(klon) ! evaporation et sa derivee
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
-      REAL,allocatable,save :: dlw(:)    ! derivee infra rouge
-c$OMP THREADPRIVATE(dlw)
-cym
-cym      SAVE dlw
-cym
+
       REAL bils(klon) ! bilan de chaleur au sol
       REAL wfbilo(klon,nbsrf) ! bilan d'eau, pour chaque
@@ -892,7 +839,5 @@
       REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
 C                             ! type de sous-surface et pondere par la fraction
-      REAL,allocatable,save :: fder(:) ! Derive de flux (sensible et latente)
-c$OMP THREADPRIVATE(fder) 
-cym      save fder
+      REAL fder(klon)         
       REAL ve(klon) ! integr. verticale du transport meri. de l'energie
       REAL vq(klon) ! integr. verticale du transport meri. de l'eau
@@ -900,7 +845,5 @@
       REAL uq(klon) ! integr. verticale du transport zonal de l'eau
 c
-      REAL,allocatable,save :: frugs(:,:) ! longueur de rugosite
-c$OMP THREADPRIVATE(frugs) 
-cym      save frugs
+      REAL frugs(klon,nbsrf)
       REAL zxrugs(klon) ! longueur de rugosite
 c
@@ -944,5 +887,4 @@
       EXTERNAL alboc     ! calculer l'albedo sur ocean
       EXTERNAL ajsec     ! ajustement sec
-      EXTERNAL clmain    ! couche limite 
       EXTERNAL conlmd    ! convection (schema LMD)
 cKE43
@@ -1047,4 +989,5 @@
 c
       REAL zxtsol(klon), zxqsurf(klon), zxsnow(klon), zxfluxlat(klon)
+      REAL zxsnow_dummy(klon)
 c
       REAL dist, rmu0(klon), fract(klon)
@@ -1070,27 +1013,5 @@
 cym      REAL zx_aire(iim,jjmp1)
 c
-cIM cf. AM Variables locales pour la CLA (hbtm2)
-c
-      REAL,SAVE,ALLOCATABLE :: pblh(:, :)           ! Hauteur de couche limite
-c$OMP THREADPRIVATE(pblh)
-      REAL,SAVE,ALLOCATABLE :: plcl(:, :)           ! Niveau de condensation de la CLA
-c$OMP THREADPRIVATE(plcl)
-      REAL,SAVE,ALLOCATABLE :: capCL(:, :)          ! CAPE de couche limite
-c$OMP THREADPRIVATE(capCL)
-      REAL,SAVE,ALLOCATABLE :: oliqCL(:, :)          ! eau_liqu integree de couche limite
-c$OMP THREADPRIVATE(oliqCL)
-      REAL,SAVE,ALLOCATABLE :: cteiCL(:, :)          ! cloud top instab. crit. couche limite
-c$OMP THREADPRIVATE(cteiCL)
-      REAL,SAVE,ALLOCATABLE :: pblt(:, :)          ! T a la Hauteur de couche limite
-c$OMP THREADPRIVATE(pblt)
-      REAL,SAVE,ALLOCATABLE :: therm(:, :)
-c$OMP THREADPRIVATE(therm)
-      REAL,SAVE,ALLOCATABLE :: trmb1(:, :)          ! deep_cape
-c$OMP THREADPRIVATE(trmb1)
-      REAL,SAVE,ALLOCATABLE :: trmb2(:, :)          ! inhibition 
-c$OMP THREADPRIVATE(trmb2)
-      REAL,SAVE,ALLOCATABLE :: trmb3(:, :)          ! Point Omega
-c$OMP THREADPRIVATE(trmb3)
-c Grdeurs de sorties
+c Grandeurs de sorties
       REAL s_pblh(klon), s_lcl(klon), s_capCL(klon)
       REAL s_oliqCL(klon), s_cteiCL(klon), s_pblt(klon)
@@ -1246,7 +1167,4 @@
 cIM RH a 2m (la surface)
       REAL rh2m(klon), qsat2m(klon)
-      REAL zx_rh2m(klon,nbsrf), zx_qsat2m(klon,nbsrf)
-      REAL zx_qs1(klon,nbsrf), zx_t1(klon,nbsrf), zdelta1(klon,nbsrf)
-      REAL zcor1(klon,nbsrf)
       REAL tpot(klon), tpote(klon)
       REAL Lheat
@@ -1370,7 +1288,8 @@
       REAL ZRCPD
 c-jld ec_conser
+      REAL t2m(klon,nbsrf)  ! temperature a 2m
+      REAL q2m(klon,nbsrf)  ! humidite a 2m
+
 cIM: t2m, q2m, u10m, v10m et t2mincels, t2maxcels
-      REAL,SAVE,ALLOCATABLE :: t2m(:,:), q2m(:,:)   !temperature, humidite a 2m
-c$OMP THREADPRIVATE(t2m,q2m)
       REAL,SAVE,ALLOCATABLE :: u10m(:,:), v10m(:,:) !vents a 10m
 c$OMP THREADPRIVATE(u10m,v10m)
@@ -1420,5 +1339,4 @@
 c Declaration des constantes et des fonctions thermodynamiques
 c
-      REAL Field_tmp(klon_glo,klevp1)
       LOGICAL,SAVE :: first=.true.
 c$OMP THREADPRIVATE(first)
@@ -1443,12 +1361,8 @@
       aam=0.
       torsfc=0.
-cym => pour le couple ocean => revoir dans clmain/intersurf
-      fluxg(:)=0.
-      fluxo(:)=0.      
 
       if (first) then 
       
       allocate( t_ancien(klon,klev), q_ancien(klon,klev))
-      allocate( q2(klon,klev+1,nbsrf))
       allocate( swdn0(klon,klevp1), swdn(klon,klevp1))
       allocate( swup0(klon,klevp1), swup(klon,klevp1))
@@ -1464,11 +1378,5 @@
       allocate( rlon(klon))
       allocate( ftsol(klon,nbsrf))
-      allocate( ftsoil(klon,nsoilmx,nbsrf))
-      allocate( fevap(klon,nbsrf))
-      allocate( fluxlat(klon,nbsrf))
       allocate( deltat(klon))
-      allocate( fqsurf(klon,nbsrf))
-      allocate( qsol(klon))
-      allocate( fsnow(klon,nbsrf))
       allocate( falbe(klon,nbsrf))
       allocate( falblw(klon,nbsrf))
@@ -1482,7 +1390,5 @@
       allocate( rugoro(klon))
       allocate( zuthe(klon),zvthe(klon))
-      allocate( agesno(klon,nbsrf))
       allocate( alb_neig(klon))
-      allocate( run_off_lic_0(klon))
       allocate( ema_workcbmf(klon))   
       allocate( ema_cbmf(klon)) 
@@ -1499,7 +1405,4 @@
       allocate( snow_fall(klon) )
       allocate( total_rain(klon), nday_rain(klon))
-      allocate( dlw(klon)   )
-      allocate( fder(klon) )
-      allocate( frugs(klon,nbsrf) )
       allocate( pctsrf(klon,nbsrf))
       allocate( albsol(klon))
@@ -1546,22 +1449,8 @@
       allocate( newsst(klon))
       allocate( zqasc(klon,klev))
-      allocate( therm(klon, nbsrf))
       allocate( rain_con(klon))
-      allocate( pblt(klon, nbsrf))
-      allocate( t2m(klon,nbsrf), q2m(klon,nbsrf) )  
       allocate( u10m(klon,nbsrf), v10m(klon,nbsrf)) 
       allocate( topswad(klon), solswad(klon))
       allocate( topswai(klon), solswai(klon) )
-      allocate( ffonte(klon,nbsrf))
-      allocate( fqcalving(klon,nbsrf))
-      allocate( fqfonte(klon,nbsrf)) 
-      allocate( pblh(klon, nbsrf))
-      allocate( plcl(klon, nbsrf))  
-      allocate( capCL(klon, nbsrf))   
-      allocate( oliqCL(klon, nbsrf))       
-      allocate( cteiCL(klon, nbsrf))       
-      allocate( trmb1(klon, nbsrf))   
-      allocate( trmb2(klon, nbsrf))     
-      allocate( trmb3(klon, nbsrf)) 
       allocate( clwcon0(klon,klev),rnebcon0(klon,klev))
       allocate( tau_ae(klon,klev,2), piz_ae(klon,klev,2))
@@ -1576,5 +1465,4 @@
 	rnebcon(:,:)=0.
 	ratqs(:,:)=0.
-	run_off_lic_0(:)=0.
 	sollw(:)=0.
 	ema_work1(:,:)=0.
@@ -1615,9 +1503,4 @@
          u10m(:,:)=0.
          v10m(:,:)=0.
-         t2m(:,:)=0.
-         q2m(:,:)=0.
-         ffonte(:,:)=0.
-         fqcalving(:,:)=0.
-	 fqfonte(:,:)=0.
          piz_ae(:,:,:)=0.
          tau_ae(:,:,:)=0.
@@ -1643,21 +1526,5 @@
 c        histoW(:,:,:,:) = 0.0
 ! fin anne
-! Anne 12/09/2005
-
-         pblh(:,:)   =0.        ! Hauteur de couche limite
-         plcl(:,:)   =0.        ! Niveau de condensation de la CLA
-         capCL(:,:)  =0.        ! CAPE de couche limite
-         oliqCL(:,:) =0.        ! eau_liqu integree de couche limite
-         cteiCL(:,:) =0.        ! cloud top instab. crit. couche limite
-         pblt(:,:)   =0.        ! T a la Hauteur de couche limite
-         therm(:,:)  =0.
-         trmb1(:,:)  =0.        ! deep_cape
-         trmb2(:,:)  =0.        ! inhibition 
-         trmb3(:,:)  =0.        ! Point Omega
-! fin Anne
-
-cym
-         wfbils(:,:)=0
-cym      
+
 cIM      
          IF (ip_ebil_phy.ge.1) d_h_vcol_phy=0.
@@ -1677,19 +1544,15 @@
 c Initialiser les compteurs:
 c
-
-         frugs = 0.
          itap    = 0
          itaprad = 0
+
          CALL phyetat0 ("startphy.nc",dtime,co2_ppm_etat0,solaire_etat0,
-     .       rlat,rlon,pctsrf, ftsol,ftsoil,
-cIM "slab" ocean
-     .       ocean, tslab,seaice,
-     .       fqsurf,qsol,fsnow,
-cIM 220306  .       falbe, falblw, fevap, rain_fall,snow_fall,solsw, sollwdown,
-     .       falbe, falblw, fevap, rain_fall,snow_fall,solsw, sollw,
-     .       dlw,radsol,frugs,agesno,clesphy0,
+     .       rlat,rlon,pctsrf, ftsol,
+     .       ocean, ok_veget,
+     .       falbe, falblw, rain_fall,snow_fall,
+     .       solsw, sollw,
+     .       radsol,clesphy0,
      .       zmea,zstd,zsig,zgam,zthe,zpic,zval,rugoro,tabcntr0,
-     .       t_ancien, q_ancien, ancien_ok, rnebcon, ratqs,clwcon, 
-     .       run_off_lic_0)
+     .       t_ancien, q_ancien, ancien_ok, rnebcon, ratqs,clwcon)
 
        DO i=1,klon
@@ -1697,12 +1560,10 @@
      $       pctsrf(i, is_oce) + pctsrf(i, is_sic)  - 1.) .GT. EPSFRA) 
      $       THEN 
-             WRITE(*,*) 'physiq : pb sous surface au point ', i, 
-     $           pctsrf(i, 1 : nbsrf)
+            WRITE(*,*)
+     $   'physiq apres lecture de restart: pb sous surface au point ',
+     $   i, pctsrf(i, 1 : nbsrf)
          ENDIF 
       ENDDO
- 
-c   ATTENTION : il faudra a terme relire q2 dans l'etat initial
-         q2(:,:,:)=1.e-8
-c
+
          radpas = NINT( 86400./dtime/nbapp_rad)
 c
@@ -1717,9 +1578,5 @@
 cIM cf. AM 081204 END
 c
-         IF(ocean.NE.'force ') THEN
-          ok_ocean=.TRUE.
-         ENDIF
-c
-         CALL printflag( tabcntr0,radpas,ok_ocean,ok_oasis ,ok_journe,
+         CALL printflag( tabcntr0,radpas,ok_journe,
      ,                    ok_instan, ok_region )
 c
@@ -1780,16 +1637,16 @@
 c34EK
          IF (ok_orodr) THEN
-         DO i=1,klon
-         rugoro(i) = MAX(1.0e-05, zstd(i)*zsig(i)/2.0)
-         ENDDO
-         CALL SUGWD(klon,klev,paprs,pplay)
-         DO i=1,klon
-         zuthe(i)=0.
-         zvthe(i)=0.
-         if(zstd(i).gt.10.)then
-           zuthe(i)=(1.-zgam(i))*cos(zthe(i))
-           zvthe(i)=(1.-zgam(i))*sin(zthe(i))
-         endif
-         ENDDO
+           DO i=1,klon
+             rugoro(i) = MAX(1.0e-05, zstd(i)*zsig(i)/2.0)
+           ENDDO
+           CALL SUGWD(klon,klev,paprs,pplay)
+           DO i=1,klon
+             zuthe(i)=0.
+             zvthe(i)=0.
+             if(zstd(i).gt.10.)then
+               zuthe(i)=(1.-zgam(i))*cos(zthe(i))
+               zvthe(i)=(1.-zgam(i))*sin(zthe(i))
+             endif
+           ENDDO
          ENDIF
 c
@@ -1851,18 +1708,5 @@
          ecrit_tra = ecrit_tra * un_jour
 cIM 030306 END
-c
-c Initialiser le couplage si necessaire
-c
-      npas = 0
-      nexca = 0
-      if (ocean == 'couple') then
-        npas = itaufin/ iphysiq
-        nexca = 86400 / dtime
-        write(lunout,*)' ##### Ocean couple #####'
-        write(lunout,*)' Valeurs des pas de temps'
-        write(lunout,*)' npas = ', npas
-        write(lunout,*)' nexca = ', nexca
-      endif        
-c
+
       capemaxcels = 't_max(X)'
       t2mincels = 't_min(X)'
@@ -2142,28 +1986,5 @@
 C
       END IF 
-C
-c
-c Appeler la diffusion verticale (programme de couche limite)
-c
-      DO i = 1, klon
-c       if (.not. ok_veget) then
-c          frugs(i,is_ter) = SQRT(frugs(i,is_ter)**2+rugoro(i)**2)
-c       endif 
-c         frugs(i,is_lic) = rugoro(i)
-c         frugs(i,is_oce) = rugmer(i)
-c         frugs(i,is_sic) = 0.001
-         zxrugs(i) = 0.0
-      ENDDO
-      DO nsrf = 1, nbsrf
-      DO i = 1, klon
-c         frugs(i,nsrf) = MAX(frugs(i,nsrf),0.001)
-        frugs(i,nsrf) = MAX(frugs(i,nsrf),0.000015)
-      ENDDO
-      ENDDO
-      DO nsrf = 1, nbsrf
-      DO i = 1, klon
-            zxrugs(i) = zxrugs(i) + frugs(i,nsrf)*pctsrf(i,nsrf)
-      ENDDO
-      ENDDO
+
 c
 C calculs necessaires au calcul de l'albedo dans l'interface
@@ -2176,41 +1997,4 @@
         rmu0 = -999.999
       ENDIF
-c
-C     Calcul de l'abedo moyen par maille
-      albsol(:)=0.
-      albsollw(:)=0.
-      DO nsrf = 1, nbsrf
-      DO i = 1, klon
-         albsol(i) = albsol(i) + falbe(i,nsrf) * pctsrf(i,nsrf)
-         albsollw(i) = albsollw(i) + falblw(i,nsrf) * pctsrf(i,nsrf)
-      ENDDO
-      ENDDO
-C
-C     Repartition sous maille des flux LW et SW
-C Modif OM+PASB+JLD
-C Repartition du longwave par sous-surface linearisee
-Cn
-
-       DO nsrf = 1, nbsrf
-       DO i = 1, klon
-c@$$        fsollw(i,nsrf) = sollwdown(i) - RSIGMA*ftsol(i,nsrf)**4
-c@$$        fsollw(i,nsrf) = sollw(i)
-         fsollw(i,nsrf) = sollw(i)
-     $      + 4.0*RSIGMA*ztsol(i)**3 * (ztsol(i)-ftsol(i,nsrf))
-         fsolsw(i,nsrf) = solsw(i)*(1.-falbe(i,nsrf))/(1.-albsol(i))
-       ENDDO
-       ENDDO
-      
-cYM   !!!!!!!!!!!!!!!!!!!!!!!!!!!!
-cYM         Attention verrue
-cYM    ---> A supprimer plus tard       
-cYM         pour etre integre dans
-cYM         ORCHIDEE       
-      DO i = 1, klon
-        sollwdown(i)=sollw(i)+RSIGMA*ztsol(i)**4
-      ENDDO
-cYM  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!      
-      
-      fder = dlw
 
       if (mydebug) then
@@ -2220,70 +2004,53 @@
 	call writefield_phy('q_seri',q_seri,llm)
       endif
-  
-      IF (check) THEN
-       amn=MIN(tslab(1),1000.)
-       amx=MAX(tslab(1),-1000.)
-       DO i=2, klon
-        amn=MIN(tslab(i),amn)
-        amx=MAX(tslab(i),amx)
-       ENDDO
-c
-       PRINT*,' debut avant clqh min max tslab',amn,amx
-      ENDIF !(check) THEN
-c
-      CALL clmain(dtime,itap,date0,pctsrf,pctsrf_new,
-     e            t_seri,q_seri,u_seri,v_seri,
-     e            julien, rmu0, co2_ppm, 
-     e            ok_veget, ocean, npas, nexca, ftsol,
-     $            soil_model,cdmmax, cdhmax,
-     $            ksta, ksta_ter, ok_kzmin, ftsoil, qsol, 
-cIM BAD    $            paprs,pplay,radsol, fsnow,fqsurf,fevap,falbe,falblw,
-     $            paprs,pplay, fsnow,fqsurf,fevap,falbe,falblw,
-     $            fluxlat,
-     e            rain_fall, snow_fall,
-     e            fsolsw, fsollw, sollwdown, fder,
-     e            rlon, rlat, cuphy, cvphy, frugs,
-     e            debut, lafin, agesno,rugoro ,
-     s            d_t_vdf,d_q_vdf,d_u_vdf,d_v_vdf,d_ts,
-     s            fluxt,fluxq,fluxu,fluxv,cdragh,cdragm,
-     s            q2,
-     s            dsens, devap,
-     s            ycoefh,yu1,yv1, t2m, q2m, u10m, v10m,
-     s            pblh,capCL,oliqCL,cteiCL,pblT,
-     s            therm,trmb1,trmb2,trmb3,plcl,
-     s            fqcalving, fqfonte,ffonte, run_off_lic_0,
-cIM "slab" ocean
-     s            fluxo, fluxg, tslab, seaice) 
-c
-CXXX PB
-CXXX Incrementation des flux
-CXXX
-
-      zxfluxt=0.
-      zxfluxq=0.
-      zxfluxu=0.
-      zxfluxv=0.
-      DO nsrf = 1, nbsrf
-        DO k = 1, klev
-          DO i = 1, klon
-            zxfluxt(i,k) = zxfluxt(i,k) + 
-     $          fluxt(i,k,nsrf) * pctsrf( i, nsrf)
-            zxfluxq(i,k) = zxfluxq(i,k) + 
-     $          fluxq(i,k,nsrf) * pctsrf( i, nsrf)
-            zxfluxu(i,k) = zxfluxu(i,k) + 
-     $          fluxu(i,k,nsrf) * pctsrf( i, nsrf)
-            zxfluxv(i,k) = zxfluxv(i,k) + 
-     $          fluxv(i,k,nsrf) * pctsrf( i, nsrf)
-          END DO 
-        END DO 
-      END DO 
-      DO i = 1, klon
-         sens(i) = - zxfluxt(i,1) ! flux de chaleur sensible au sol
-c         evap(i) = - fluxq(i,1) ! flux d'evaporation au sol
-         evap(i) = - zxfluxq(i,1) ! flux d'evaporation au sol
-         fder(i) = dlw(i) + dsens(i) + devap(i)
-      ENDDO
-
-
+
+ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c Appel au pbl_surface : Planetary Boudary Layer et Surface
+c Cela implique tous les interactions des sous-surfaces et la partie diffusion 
+c turbulent du couche limit. 
+c 
+c Certains varibales de sorties de pbl_surface sont utiliser que pour 
+c ecriture des fihiers hist_XXXX.nc, ces sont :
+c   qsol,      zq2m,      s_pblh,  s_lcl,
+c   s_capCL,   s_oliqCL,  s_cteiCL,s_pblT,
+c   s_therm,   s_trmb1,   s_trmb2, s_trmb3,
+c   zxrugs,    zu10m,     zv10m,   fder,
+c   zxqsurf,   rh2m,      zxfluxu, zxfluxv,
+c   frugs,     agesno,    fsollw,  fsolsw,
+c   d_ts,      fevap,     fluxlat, t2m,
+c   wfbils,    wfbilo,    fluxt,   fluxu, fluxv,
+c
+c Certains ne sont pas utiliser du tout : 
+c   dsens, devap, zxsnow, zxfluxt, zxfluxq, q2m, fluxq
+c
+      CALL pbl_surface( 
+     e     dtime,     date0,     itap,    julien,
+     e     debut,     lafin,
+     e     rlon,      rlat,      rugoro,  rmu0,     
+     e     rain_fall, snow_fall, solsw,   sollw,    
+     e     t_seri,    q_seri,    u_seri,  v_seri,   
+     e     pplay,     paprs,     pctsrf,            
+     +     ftsol,     falbe,     falblw,  u10m,   v10m,
+     s     sollwdown, cdragh,    cdragm,  yu1,    yv1,
+     s     albsol,    albsollw,  sens,    evap,  
+     s     zxtsol,    zxfluxlat, zt2m,    qsat2m, 
+     s     d_t_vdf,   d_q_vdf,   d_u_vdf, d_v_vdf,
+     s     ycoefh,    pctsrf_new,                
+     d     qsol,      zq2m,      s_pblh,  s_lcl,
+     d     s_capCL,   s_oliqCL,  s_cteiCL,s_pblT,
+     d     s_therm,   s_trmb1,   s_trmb2, s_trmb3,
+     d     zxrugs,    zu10m,     zv10m,   fder,
+     d     zxqsurf,   rh2m,      zxfluxu, zxfluxv,
+     d     frugs,     agesno,    fsollw,  fsolsw,
+     d     d_ts,      fevap,     fluxlat, t2m,
+     d     wfbils,    wfbilo,    fluxt,   fluxu,  fluxv,
+     -     dsens,     devap,     zxsnow,
+     -     zxfluxt,   zxfluxq,   q2m,     fluxq )
+c
+c
+ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+      pctsrf(:,:) = pctsrf_new(:,:)
+      
       DO k = 1, klev
       DO i = 1, klon
@@ -2303,7 +2070,6 @@
 
 
-cIM
       IF (ip_ebil_phy.ge.2) THEN 
-        ztit='after clmain'
+        ztit='after surface_main'
         CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
      e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
@@ -2315,127 +2081,5 @@
      s      , fs_bound, fq_bound )
       END IF 
-C
-c
-c Incrementer la temperature du sol
-c
-      DO i = 1, klon
-         zxtsol(i) = 0.0
-         zxfluxlat(i) = 0.0
-c
-         zt2m(i) = 0.0
-         zq2m(i) = 0.0
-         zu10m(i) = 0.0
-         zv10m(i) = 0.0
-cIM cf JLD ??
-         zxffonte(i) = 0.0
-         zxfqcalving(i) = 0.0
-	 zxfqfonte(i) = 0.0
-cIM cf. AM 081204 BEG
-c
-         s_pblh(i) = 0.0 
-         s_lcl(i) = 0.0 
-         s_capCL(i) = 0.0
-         s_oliqCL(i) = 0.0
-         s_cteiCL(i) = 0.0
-         s_pblT(i) = 0.0
-         s_therm(i) = 0.0
-         s_trmb1(i) = 0.0
-         s_trmb2(i) = 0.0
-         s_trmb3(i) = 0.0
-c
-         IF ( abs( pctsrf(i, is_ter) + pctsrf(i, is_lic) + 
-     $       pctsrf(i, is_oce) + pctsrf(i, is_sic)  - 1.) .GT. EPSFRA) 
-     $       THEN 
-             WRITE(*,*) 'physiq : pb sous surface au point ', i, 
-     $           pctsrf(i, 1 : nbsrf)
-         ENDIF 
-      ENDDO
-      DO nsrf = 1, nbsrf
-        DO i = 1, klon
-c        IF (pctsrf(i,nsrf) .GE. EPSFRA) THEN 
-            ftsol(i,nsrf) = ftsol(i,nsrf) + d_ts(i,nsrf)
-cIM cf. JLD
-            wfbils(i,nsrf) = ( fsolsw(i,nsrf) + fsollw(i,nsrf)
-     $         + fluxt(i,1,nsrf) + fluxlat(i,nsrf) ) * pctsrf(i,nsrf)
-cIM
-            wfbilo(i,nsrf) = ( fevap(i,nsrf) - 
-     $      (rain_fall(i) + snow_fall(i)) ) * pctsrf(i,nsrf)
-            zxtsol(i) = zxtsol(i) + ftsol(i,nsrf)*pctsrf(i,nsrf)
-            zxfluxlat(i) = zxfluxlat(i) + fluxlat(i,nsrf)*pctsrf(i,nsrf)
-cccIM
-            zt2m(i) = zt2m(i) + t2m(i,nsrf)*pctsrf(i,nsrf)
-            zq2m(i) = zq2m(i) + q2m(i,nsrf)*pctsrf(i,nsrf)
-            zu10m(i) = zu10m(i) + u10m(i,nsrf)*pctsrf(i,nsrf)
-            zv10m(i) = zv10m(i) + v10m(i,nsrf)*pctsrf(i,nsrf)
-cIM cf JLD ??
-            zxffonte(i) = zxffonte(i) + ffonte(i,nsrf)*pctsrf(i,nsrf)
-            zxfqcalving(i) = zxfqcalving(i) + 
-     .                      fqcalving(i,nsrf)*pctsrf(i,nsrf)
-            zxfqfonte(i) = zxfqfonte(i) + 
-     .                      fqfonte(i,nsrf)*pctsrf(i,nsrf)
-cIM cf. AM 081204 BEG
-            s_pblh(i) = s_pblh(i) + pblh(i,nsrf)*pctsrf(i,nsrf)
-            s_lcl(i) = s_lcl(i) + plcl(i,nsrf)*pctsrf(i,nsrf)
-            s_capCL(i) = s_capCL(i) + capCL(i,nsrf) *pctsrf(i,nsrf)
-            s_oliqCL(i) = s_oliqCL(i) + oliqCL(i,nsrf) *pctsrf(i,nsrf)
-            s_cteiCL(i) = s_cteiCL(i) + cteiCL(i,nsrf) *pctsrf(i,nsrf)
-            s_pblT(i) = s_pblT(i) + pblT(i,nsrf) *pctsrf(i,nsrf)
-            s_therm(i) = s_therm(i) + therm(i,nsrf) *pctsrf(i,nsrf)
-            s_trmb1(i) = s_trmb1(i) + trmb1(i,nsrf) *pctsrf(i,nsrf)
-            s_trmb2(i) = s_trmb2(i) + trmb2(i,nsrf) *pctsrf(i,nsrf)
-            s_trmb3(i) = s_trmb3(i) + trmb3(i,nsrf) *pctsrf(i,nsrf)
-c        ENDIF 
-        ENDDO
-      ENDDO
-
-      IF (check) THEN
-       amn=MIN(ftsol(1,is_ter),1000.)
-       amx=MAX(ftsol(1,is_ter),-1000.)
-       DO i=2, klon
-        amn=MIN(ftsol(i,is_ter),amn)
-        amx=MAX(ftsol(i,is_ter),amx)
-       ENDDO
-c
-       PRINT*,' debut apres d_ts min max ftsol',itap,amn,amx
-      ENDIF !(check) THEN
-c
-c Si une sous-fraction n'existe pas, elle prend la temp. moyenne
-c
-      DO nsrf = 1, nbsrf
-        DO i = 1, klon
-          IF (pctsrf(i,nsrf) .LT. epsfra.OR.t2m(i,nsrf).EQ.0.) THEN
-           ftsol(i,nsrf) = zxtsol(i)
-           t2m(i,nsrf) = zt2m(i)
-           q2m(i,nsrf) = zq2m(i)
-           u10m(i,nsrf) = zu10m(i)
-           v10m(i,nsrf) = zv10m(i)
-           ffonte(i,nsrf) = zxffonte(i)
-           fqcalving(i,nsrf) = zxfqcalving(i)
-           fqfonte(i,nsrf) = zxfqfonte(i)
-           pblh(i,nsrf)=s_pblh(i)
-           plcl(i,nsrf)=s_lcl(i)
-           capCL(i,nsrf)=s_capCL(i)
-           oliqCL(i,nsrf)=s_oliqCL(i) 
-           cteiCL(i,nsrf)=s_cteiCL(i)
-           pblT(i,nsrf)=s_pblT(i)
-           therm(i,nsrf)=s_therm(i)
-           trmb1(i,nsrf)=s_trmb1(i)
-           trmb2(i,nsrf)=s_trmb2(i)
-           trmb3(i,nsrf)=s_trmb3(i)
-          ENDIF
-        ENDDO
-      ENDDO
-c
-c Calculer la derive du flux infrarouge
-c
-cXXX      DO nsrf = 1, nbsrf
-      DO i = 1, klon
-cXXX        IF (pctsrf(i,nsrf) .GE. EPSFRA) THEN 
-            dlw(i) = - 4.0*RSIGMA*zxtsol(i)**3 
-cXXX     .          *(ftsol(i,nsrf)-zxtsol(i))
-cXXX     .          *pctsrf(i,nsrf)
-cXXX        ENDIF 
-cXXX      ENDDO
-      ENDDO
+
 c
 c Appeler la convection (au choix)
@@ -2473,5 +2117,5 @@
       ELSE IF (iflag_con.EQ.2) THEN
       CALL conflx(dtime, paprs, pplay, t_seri, q_seri,
-     e            conv_t, conv_q, zxfluxq(1,1), omega,
+     e            conv_t, conv_q, -evap, omega,
      s            d_t_con, d_q_con, rain_con, snow_con,
      s            pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
@@ -2956,34 +2600,5 @@
       ENDDO
       ENDDO
-c
-cIM Calculer l'humidite relative a 2m (rh2m) pour diagnostique
-cIM ajout dependance type surface
-      DO i = 1, klon
-       rh2m(i)=0.
-       qsat2m(i)=0.
-      DO nsrf=1, nbsrf
-         zx_t1(i,nsrf) = t2m(i,nsrf)
-         IF (thermcep) THEN
-            zdelta1(i,nsrf) = MAX(0.,SIGN(1.,rtt-zx_t1(i,nsrf)))
-            zx_qs1(i,nsrf)  = r2es * 
-     $      FOEEW(zx_t1(i,nsrf),zdelta1(i,nsrf))/paprs(i,1)
-            zx_qs1(i,nsrf)  = MIN(0.5,zx_qs1(i,nsrf))
-            zcor1(i,nsrf)   = 1./(1.-retv*zx_qs1(i,nsrf))
-            zx_qs1(i,nsrf)  = zx_qs1(i,nsrf)*zcor1(i,nsrf)
-         ELSE
-c
-           IF (zx_t.LT.RTT) THEN
-              zx_qs = qsats(zx_t)/paprs(i,1)
-           ELSE
-              zx_qs = qsatl(zx_t)/paprs(i,1)
-           ENDIF
-         ENDIF
-       zx_rh2m(i,nsrf) = q2m(i,nsrf)/zx_qs1(i,nsrf)
-       zx_qsat2m(i,nsrf)=zx_qs1(i,nsrf)
-       rh2m(i) = rh2m(i)+zx_rh2m(i,nsrf)*pctsrf(i,nsrf)
-       qsat2m(i)=qsat2m(i)+zx_qsat2m(i,nsrf)*pctsrf(i,nsrf)
-      ENDDO !nsrf
-      ENDDO
-c
+
 cIM Calcul temp.potentielle a 2m (tpot) et temp. potentielle 
 c   equivalente a 2m (tpote) pour diagnostique
@@ -3023,4 +2638,6 @@
 #endif
 
+           zxsnow_dummy(:) = 0.0
+
            CALL chemhook_begin (calday,
 #if defined(INCA) && !defined(INCA_CH4) && !defined(INCA_NMHC) && !defined(INCA_AER)
@@ -3042,5 +2659,5 @@
      $                          q_seri,
      $                          zxtsol,
-     $                          zxsnow,
+     $                          zxsnow_dummy,
      $                          solsw,
      $                          albsol,
@@ -3099,4 +2716,5 @@
 c
       IF (MOD(itaprad,radpas).EQ.0) THEN
+
       DO i = 1, klon
          albsol(i) = falbe(i,is_oce) * pctsrf(i,is_oce)
